using System;
using System.Threading;

class AsyncCallDemo
{
	public delegate int MyDelegate(int a, int b);

	public int Sum(int a, int b)
	{
		Thread.Sleep(3000);
		return a + b;
	}

	static void Main(string[] args)
	{
		MyDelegate asyncCall = new MyDelegate(
			new AsyncCallDemo().Sum);
		Console.WriteLine("Starting method async.");
		IAsyncResult status = asyncCall.BeginInvoke(5, 6, null, null);
		Console.WriteLine("Async method is now working...");
		
		Console.WriteLine("Calling EndInvoke()...");
		Console.WriteLine("It will block until method is finished. ");
		int result = asyncCall.EndInvoke(status);
		Console.WriteLine("EndInvoke() returned.");
		Console.WriteLine("Result = {0}", result);
	}
}