using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;

namespace Demo_6_Priority_State_Suspend_Resume_Interrupt_Abort
{
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.Button buttonSuspend;
		private System.Windows.Forms.Button buttonResume;
		private System.Windows.Forms.Button buttonInterrupt;
		private System.Windows.Forms.Button buttonAbort;
		private System.Windows.Forms.ListBox listBoxThreadState;
		private System.ComponentModel.Container components = null;

		private Thread mBackgroundThread;
		private Thread mStatusWatchThread;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.buttonSuspend = new System.Windows.Forms.Button();
			this.buttonResume = new System.Windows.Forms.Button();
			this.buttonInterrupt = new System.Windows.Forms.Button();
			this.buttonAbort = new System.Windows.Forms.Button();
			this.listBoxThreadState = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(16, 16);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.Size = new System.Drawing.Size(296, 120);
			this.textBoxMessage.TabIndex = 0;
			this.textBoxMessage.Text = "";
			// 
			// buttonSuspend
			// 
			this.buttonSuspend.Location = new System.Drawing.Point(328, 16);
			this.buttonSuspend.Name = "buttonSuspend";
			this.buttonSuspend.Size = new System.Drawing.Size(88, 23);
			this.buttonSuspend.TabIndex = 1;
			this.buttonSuspend.Text = "Suspend()";
			this.buttonSuspend.Click += new System.EventHandler(this.buttonSuspend_Click);
			// 
			// buttonResume
			// 
			this.buttonResume.Location = new System.Drawing.Point(328, 48);
			this.buttonResume.Name = "buttonResume";
			this.buttonResume.Size = new System.Drawing.Size(88, 23);
			this.buttonResume.TabIndex = 2;
			this.buttonResume.Text = "Resume()";
			this.buttonResume.Click += new System.EventHandler(this.buttonResume_Click);
			// 
			// buttonInterrupt
			// 
			this.buttonInterrupt.Location = new System.Drawing.Point(328, 80);
			this.buttonInterrupt.Name = "buttonInterrupt";
			this.buttonInterrupt.Size = new System.Drawing.Size(88, 23);
			this.buttonInterrupt.TabIndex = 4;
			this.buttonInterrupt.Text = "Interrupt()";
			this.buttonInterrupt.Click += new System.EventHandler(this.buttonInterrupt_Click);
			// 
			// buttonAbort
			// 
			this.buttonAbort.Location = new System.Drawing.Point(328, 112);
			this.buttonAbort.Name = "buttonAbort";
			this.buttonAbort.Size = new System.Drawing.Size(88, 24);
			this.buttonAbort.TabIndex = 6;
			this.buttonAbort.Text = "Abort()";
			this.buttonAbort.Click += new System.EventHandler(this.buttonAbort_Click);
			// 
			// listBoxThreadState
			// 
			this.listBoxThreadState.Location = new System.Drawing.Point(16, 152);
			this.listBoxThreadState.Name = "listBoxThreadState";
			this.listBoxThreadState.Size = new System.Drawing.Size(400, 134);
			this.listBoxThreadState.TabIndex = 8;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(434, 303);
			this.Controls.Add(this.listBoxThreadState);
			this.Controls.Add(this.buttonAbort);
			this.Controls.Add(this.buttonInterrupt);
			this.Controls.Add(this.buttonResume);
			this.Controls.Add(this.buttonSuspend);
			this.Controls.Add(this.textBoxMessage);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Priority, State, Suspend, Resume, Interrupt and Abort Demo";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		public void DisplayThreadState()
		{
			string newStateMsg = String.Format("Thread state = [{0}]",
				mBackgroundThread.ThreadState);

			if (listBoxThreadState.Items.Count != 0)
			{
				string oldStateMsg = (string) listBoxThreadState.Items[
					listBoxThreadState.Items.Count-1];
				if (newStateMsg != oldStateMsg)
				{
					listBoxThreadState.Items.Add(newStateMsg);
				}
			}
			else
			{
				listBoxThreadState.Items.Add(newStateMsg);
			}

			listBoxThreadState.SelectedIndex = listBoxThreadState.Items.Count-1;
		}

		public void ShowMessageInTextBox(string aMessage)
		{
			textBoxMessage.Text = aMessage;
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			BackgroundThread backgroundThread = 
				new BackgroundThread(this);
			mBackgroundThread = 
				new Thread(new ThreadStart(backgroundThread.DoDisplayMessage));
			mBackgroundThread.IsBackground = true;
			mBackgroundThread.Start();

			StatusWatchThread statusWatchThread = 
				new StatusWatchThread(this);
			mStatusWatchThread = 
				new Thread(new ThreadStart(statusWatchThread.DoStatusWatch));
			mStatusWatchThread.IsBackground = true;
			mStatusWatchThread.Priority = ThreadPriority.Highest;
			mStatusWatchThread.Start();
		}

		private void buttonSuspend_Click(object sender, System.EventArgs e)
		{
			mBackgroundThread.Suspend();
		}

		private void buttonResume_Click(object sender, System.EventArgs e)
		{
			mBackgroundThread.Resume();
		}

		private void buttonInterrupt_Click(object sender, System.EventArgs e)
		{
			mBackgroundThread.Interrupt();
		}

		private void buttonAbort_Click(object sender, System.EventArgs e)
		{
			mBackgroundThread.Abort();
		}
	}

	delegate void StringDelegate(string aString);

	public class BackgroundThread 
	{
		private const string MESSAGE = 
			"This example illustrtates how to use ThreadState, Suspend(), Resume(), " +
			"Sleep(), Interrupt(), Abort(), Priority and IsBackground methods and " +
			"properties of the System.Threading.Thread class.";

		private MainForm mMainForm;

		public BackgroundThread(MainForm aMainForm)
		{
			mMainForm = aMainForm;
		}

		public void DoDisplayMessage()
		{
			try
			{
				for (int len=1; len<=MESSAGE.Length; len++)
				{
					try
					{
						string msg = MESSAGE.Substring(0, len);
						mMainForm.Invoke(
							new StringDelegate(mMainForm.ShowMessageInTextBox),
							new object[]{msg});
					}
					catch (Exception)
					{
						return;
					}
					Thread.Sleep(100);
				}
			}
			catch (ThreadInterruptedException) 
			{
				MessageBox.Show("ThreadInterruptedException", "Info");
				return;
			}
			catch (ThreadAbortException)
			{
				MessageBox.Show("ThreadAbortException", "Info");

				// Cancel the thread aborting
				//Thread.ResetAbort();
			}
			finally
			{
				MessageBox.Show("Finally block reached.", "Info");
			}
			MessageBox.Show("Thread finished by itself.", "Info");
		}
	}

	delegate void VoidDelegate();

	public class StatusWatchThread 
	{
		private MainForm mMainForm;

		public StatusWatchThread(MainForm aMainForm)
		{
			mMainForm = aMainForm;
		}

		public void DoStatusWatch()
		{
			while (true)
			{
				try
				{
					mMainForm.Invoke(
						new VoidDelegate(mMainForm.DisplayThreadState));
				}
				catch (Exception)
				{
					return;
				}
				Thread.Sleep(100);
			}
		}
	}

}
